#include "smtp.h"
char getyyy[3]="123";


void smtp_statistics_write(xmlnode loQuery,const char *lcTagName, const char *lcUnitName, const char *lcValue)
   {
   xmlnode loStatN;
   xmlnode_put_attrib(loStatN=xmlnode_insert_tag(loQuery,"stat"),"name",lcTagName);
   xmlnode_put_attrib(loStatN,"units",lcUnitName);
   xmlnode_put_attrib(loStatN,"value",lcValue); 
   }

// S:2005-08-29 gorila@dione.zcu.cz
int smtp_out_packets_iq(smtpp par, char *type)
   {
   int liProcess=0;
   jpacket jp=par->jp;
   smtpi sin=par->sin;
   time_t now_unixtime;
   struct tm now;
   char lcPom[27];
   char *lcJID, *lcPercent,*lcAT,*lcLang,*lcDateTime,*lcName;
   struct utsname osinfo;
   spool osinfos;
   xmlnode x, loQuery, loIdentity, loStat, xData, loField, loOption;



   lcLang=xmlnode_get_attrib(jp->x, "xml:lang");

   if (lcLang==NULL)
      lcLang=sin->DefaultLang;


   if (liProcess==0 && 
       j_strcmp(xmlnode_get_attrib(jp->x, "id"),"smtp_test_jep0033")==0 &&
       j_strcmp(jp->iqns,"http://jabber.org/protocol/disco#info")==0)
      {

      if (xmlnode_get_tag(jp->x,"query/feature?var=http://jabber.org/protocol/address"))
         sin->jep0033=1;

      return -1;
      }

   
   if (liProcess==0 && j_strcmp(jp->iqns,NS_VERSION)==0 && jp->subtype==JPACKET__GET)
      {
      x= out_SetReply(xmlnode_new_tag("iq"),jp->x);
      xmlnode_put_attrib(x,"type","result");
      xmlnode_put_attrib(loQuery=xmlnode_insert_tag(x,"query"),"xmlns",NS_VERSION);
      xmlnode_insert_cdata(xmlnode_insert_tag(loQuery,"name"),smtp_name,-1);
      xmlnode_insert_cdata(xmlnode_insert_tag(loQuery,"version"),smtp_version,-1);
 
      uname(&osinfo);
      osinfos = spool_new(sin->i->p);
      spooler(osinfos,osinfo.sysname, " ", osinfo.release, " ", osinfo.machine,osinfos);

      xmlnode_insert_cdata(xmlnode_insert_tag(loQuery,"os"), spool_print(osinfos) ,-1);

      liProcess=1;
      }



   if (liProcess==0 && j_strcmp(jp->iqns,NS_GATEWAY)==0 && jp->subtype==JPACKET__GET && jp->to->user==NULL)
      {
      x= out_SetReply(xmlnode_new_tag("iq"),jp->x);
      xmlnode_put_attrib(x,"type","result");
      xmlnode_put_attrib(loQuery=xmlnode_insert_tag(x,"query"),"xmlns",NS_GATEWAY);


      xmlnode_insert_cdata(xmlnode_insert_tag(loQuery,"desc"),smtp_rc_GetString(par,lcLang,SMTP_RC_GATEWAY_DESCR),-1);
      xmlnode_insert_cdata(xmlnode_insert_tag(loQuery,"prompt"),smtp_rc_GetString(par,lcLang,SMTP_RC_GATEWAY_PROMPT),-1);

      liProcess=1;
      }


   if (liProcess==0 && j_strcmp(jp->iqns,NS_GATEWAY)==0 && jp->subtype==JPACKET__SET && jp->to->user==NULL)
      {
      x= out_SetReply(xmlnode_new_tag("iq"),jp->x);
      // check prompt element data
      /* translate the recipient into a SMTP address */
      lcJID = xmlnode_get_data(xmlnode_get_tag(jp->x,"query/prompt"));
      lcPercent = strstr(lcJID,"%");
      lcAT = strstr(lcJID,"@");
      
      if (lcPercent==NULL && lcAT==NULL)
         {
         smtp_ReplyError(par, jp, "iq", "Bad address", 405);
         }

      else
         {
         if (lcPercent!=NULL && lcAT!=NULL) // define % and @
            {
            if (lcPercent<lcAT) // % is before @
               *lcAT='\0';
            else
               {
               *lcPercent='\0';
               *lcAT='%';
               }
            }
         else    
            if (lcAT!=NULL)
               *lcAT='%';

         xmlnode_put_attrib(x,"type","result");
         xmlnode_put_attrib(loQuery=xmlnode_insert_tag(x,"query"),"xmlns",NS_GATEWAY);
         xmlnode_insert_cdata(xmlnode_insert_tag(loQuery,"prompt"),strcat(strcat(lcJID,"@"),xmlnode_get_attrib(jp->x,"to")),-1);
         }

      liProcess=1;
      }


   if (liProcess==0 && j_strcmp(jp->iqns,NS_TIME)==0 && jp->subtype==JPACKET__GET)
      {
      x= out_SetReply(xmlnode_new_tag("iq"),jp->x);
      xmlnode_put_attrib(x,"type","result");
      xmlnode_put_attrib(loQuery=xmlnode_insert_tag(x,"query"),"xmlns",NS_TIME);

      /* create UTC time */
      now_unixtime = time(NULL);
      gmtime_r(&now_unixtime, &now);
      lcPom[0]='\0';
      snprintf(lcPom, sizeof(lcPom), "%02i %s %04i %02i:%02i:%02i +0000", now.tm_mday, smtp_CMonth(now.tm_mon), now.tm_year+1900, now.tm_hour, now.tm_min, now.tm_sec);
      if (lcPom[0])
         xmlnode_insert_cdata(xmlnode_insert_tag(loQuery,"display"),lcPom,27);


      lcDateTime = (char*)pmalloc_x(sin->i->p, 18,' ');
      smtp_GetDateTime((char *)lcDateTime);
      xmlnode_insert_cdata(xmlnode_insert_tag(loQuery,"utc"),lcDateTime,-1);

//       smtp_TEST(par, par->jp);
//      smtp_ToUTF8(sin->i->p, "a  a","aa");
      liProcess=1;
      }


   if (liProcess==0 && j_strcmp(jp->iqns,NS_VCARD)==0 && jp->subtype==JPACKET__GET)
      {
      x= out_SetReply(xmlnode_new_tag("iq"),jp->x);
      xmlnode_put_attrib(x,"type","result");
      xmlnode_put_attrib(loQuery=xmlnode_insert_tag(x,"vCard"),"xmlns",NS_VCARD);
      xmlnode_insert_cdata(xmlnode_insert_tag(loQuery,"JABBERID"),xmlnode_get_attrib(jp->x,"to"),-1);
      if (jp->to->user==NULL)
         xmlnode_insert_cdata(xmlnode_insert_tag(loQuery,"FN"),smtp_name,-1);

      liProcess=1;
      }

   if (liProcess==0 && j_strcmp(jp->iqns,"http://jabber.org/protocol/disco#info")==0 && jp->subtype==JPACKET__RESULT)
      {

      }


   if (liProcess==0 && j_strcmp(jp->iqns,"http://jabber.org/protocol/disco#info")==0 && jp->subtype==JPACKET__GET)
      {
      x= out_SetReply(xmlnode_new_tag("iq"),jp->x);
      xmlnode_put_attrib(x,"type","result");

      xmlnode_put_attrib(loQuery=xmlnode_insert_tag(x,"query"),"xmlns","http://jabber.org/protocol/disco#info");
      xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"feature"),"var","http://jabber.org/protocol/disco");

      if (jp->to->user==NULL)
         {

         xmlnode_put_attrib(loIdentity=xmlnode_insert_tag(loQuery,"identity"),"category","gateway");
         xmlnode_put_attrib(loIdentity,"name",smtp_name);
         xmlnode_put_attrib(loIdentity,"type","x-smtp");

         xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"feature"),"var","http://jabber.org/protocol/stats");
         xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"feature"),"var","http://jabber.org/protocol/address");
         xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"feature"),"var","jabber:iq:gateway");
         xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"feature"),"var","jabber:iq:register");
         }
      else
         xmlnode_put_attrib(loIdentity=xmlnode_insert_tag(loQuery,"identity"),"category","client");


      xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"feature"),"var","jabber:iq:version");
      xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"feature"),"var","jabber:iq:time");
      xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"feature"),"var","vcard-temp");


      liProcess=1;
      }


   if (liProcess==0 && j_strcmp(jp->iqns,"http://jabber.org/protocol/stats")==00 &&
       jp->subtype==JPACKET__GET && jp->to->user==NULL)
      {
      x= out_SetReply(xmlnode_new_tag("iq"),jp->x);
      xmlnode_put_attrib(x,"type","result");

      xmlnode_put_attrib(loQuery=xmlnode_insert_tag(x,"query"),"xmlns","http://jabber.org/protocol/stats");

      if ((loStat=xmlnode_get_firstchild(jp->iq)))
         {


         // read all childs elements
         for (;loStat != NULL; loStat = xmlnode_get_nextsibling(loStat))
             {
	         if (loStat->type!=NTYPE_TAG)
		        continue;

             // main section
             lcName=xmlnode_get_attrib(loStat,"name");
             if (j_strcmp(lcName,"start")==0)
                {
                smtp_statistics_write(loQuery,lcName, "count",xmlnode_get_attrib(sin->statistics,"Start"));
				continue;
                }

             if (j_strcmp(lcName,"start/lastdatetime")==0)
                {
                smtp_statistics_write(loQuery,lcName, "date",xmlnode_get_attrib(sin->statistics,"StartLastDatetime"));
				continue;
                }

             // jabber side
             if (j_strcmp(lcName,"jabber/status")==0)
                {
                smtp_statistics_write(loQuery,lcName, "text",sin->cJabber_Status);
				continue;
                }

             if (j_strcmp(lcName,"jabber/messages")==0)
                {
                smtp_statistics_write(loQuery,lcName, "count",xmlnode_get_attrib(sin->statistics,"JabberMessages"));
				continue;
                }

			 if (j_strcmp(lcName,"jabber/messages/out")==0)
                {
                smtp_statistics_write(loQuery,lcName, "count",xmlnode_get_attrib(sin->statistics,"JabberMessagesOut"));
                continue;
                }

             if (j_strcmp(lcName,"jabber/messages/out/error")==0)
                {
                smtp_statistics_write(loQuery,lcName, "count",xmlnode_get_attrib(sin->statistics,"JabberMessagesOutError"));
				continue;
                }

             if (j_strcmp(lcName,"jabber/elapsed/messages")==0)
                {
                snprintf(lcPom, sizeof(lcPom), "%i\0",sin->JabberMessagesElapsed);
                smtp_statistics_write(loQuery,lcName, "count",lcPom);
				continue;
                }

             if (j_strcmp(lcName,"jabber/elapsed/messages/out")==0)
                {
                snprintf(lcPom, sizeof(lcPom), "%i\0",sin->JabberMessagesElapsedOut);
                smtp_statistics_write(loQuery,lcName, "count",lcPom);
				continue;
                }


             if (j_strcmp(lcName,"jabber/elapsed/messages/out/error")==0)
                {
                snprintf(lcPom, sizeof(lcPom), "%i\0",sin->JabberMessagesElapsedOutError);
                smtp_statistics_write(loQuery,lcName, "count",lcPom);
				continue;
                }

             // SMTP side
             if (j_strcmp(lcName,"smtp/status")==0)
                {
                smtp_statistics_write(loQuery,lcName, "text",sin->cSMTP_Status);
				continue;
                }

		     if (j_strcmp(lcName,"smtp/command/unknown")==0)
                {
                smtp_statistics_write(loQuery,lcName, "count",xmlnode_get_attrib(sin->statistics,"SMTPCommandUnknown"));
				continue;
                }

             if (j_strcmp(lcName,"smtp/elapsed/command/unknown")==0)
                {
                snprintf(lcPom, sizeof(lcPom), "%i\0",sin->SMTPElapsedCommandUnknown);
                smtp_statistics_write(loQuery,lcName, "count",lcPom);
				continue;
                }

             if (j_strcmp(lcName,"smtp/messages")==0)
                {
                smtp_statistics_write(loQuery,lcName, "count",xmlnode_get_attrib(sin->statistics,"SMTPMessages"));
				continue;
				}


             if (j_strcmp(lcName,"smtp/messages/in")==0)
                {
                smtp_statistics_write(loQuery,lcName, "count",xmlnode_get_attrib(sin->statistics,"SMTPMessagesIn"));
				continue;
                }

		     if (j_strcmp(lcName,"smtp/messages/in/error")==0)
                {
                smtp_statistics_write(loQuery,lcName, "count",xmlnode_get_attrib(sin->statistics,"SMTPMessagesInError"));
				continue;
                }
             if (j_strcmp(lcName,"smtp/elapsed/messages")==0)
                {
                snprintf(lcPom, sizeof(lcPom), "%i\0",sin->SMTPMessagesElapsed);
                smtp_statistics_write(loQuery,lcName, "count",lcPom);
				continue;
                }

             if (j_strcmp(lcName,"smtp/elapsed/messages/in")==0)
                {
                snprintf(lcPom, sizeof(lcPom), "%i\0",sin->SMTPMessagesElapsedIn);
                smtp_statistics_write(loQuery,lcName, "count",lcPom);
				continue;
                }

            if (j_strcmp(lcName,"smtp/elapsed/messages/in/error")==0)
                {
                snprintf(lcPom, sizeof(lcPom), "%i\0",sin->SMTPMessagesElapsedInError);
                smtp_statistics_write(loQuery,lcName, "count",lcPom);
				continue;
                }

		     if (j_strcmp(lcName,"smtp/spam")==0)
                {
                smtp_statistics_write(loQuery,lcName, "count",xmlnode_get_attrib(sin->statistics,"SMTPSpam"));
				continue;
                }

             if (j_strcmp(lcName,"smtp/elapsed/spam")==0)
                {
                snprintf(lcPom, sizeof(lcPom), "%i\0",sin->SMTPElapsedSpam);
                smtp_statistics_write(loQuery,lcName, "count",lcPom);
				continue;
                }



             }

         }
      else
         {
         xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","start");
         xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","start/lastdatetime");

         xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","jabber/status");

         xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","jabber/messages");
         xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","jabber/messages/out");
         xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","jabber/messages/out/error");

         xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","jabber/elapsed/messages");
         xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","jabber/elapsed/messages/out");
         xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","jabber/elapsed/messages/out/error");

		 xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","smtp/status");
		 xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","smtp/command/unknown");
		 xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","smtp/elapsed/command/unknown");

         xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","smtp/messages");
		 xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","smtp/messages/in");
		 xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","smtp/messages/in/error");

         xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","smtp/elapsed/messages");
         xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","smtp/elapsed/messages/in");
         xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","smtp/elapsed/messages/in/error");
		 
         xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","smtp/spam");
         xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","smtp/elapsed/spam");
		 }

      liProcess=1;
      }

   if (liProcess==0 && j_strcmp(jp->iqns,NS_REGISTER)==0 && jp->subtype==JPACKET__GET)
      {
      x= out_SetReply(xmlnode_new_tag("iq"),jp->x);
      xmlnode_put_attrib(x,"type","result");
      xmlnode_put_attrib(loQuery=xmlnode_insert_tag(x,"query"),"xmlns",NS_REGISTER);
	  xmlnode_insert_cdata(xmlnode_insert_tag(loQuery,"instruction"),smtp_rc_GetString(par,lcLang,SMTP_RC_REGISTER_MAIN_I),-1);

      xmlnode_put_attrib(xData=xmlnode_insert_tag(loQuery,"x"),"xmlns",NS_DATA);
	  xmlnode_insert_cdata(xmlnode_insert_tag(xData,"title"),smtp_rc_GetString(par,lcLang,SMTP_RC_REGISTER_TITLE),-1);
	  xmlnode_insert_cdata(xmlnode_insert_tag(xData,"instructions"),smtp_rc_GetString(par,lcLang,SMTP_RC_REGISTER_DATA_I),-1);



/*
Nati nastaven uivatele dle JID
pokud neexistuje, pouij nastaven z konfigu transportu
*/

	  // global settings
	  xmlnode_put_attrib(loField=xmlnode_insert_tag(xData,"field"),"type","boolean");
	  xmlnode_put_attrib(loField,"label",smtp_rc_GetString(par,lcLang,SMTP_RC_REGISTER_USEGLOBALSETTINGS_LBL));
	  xmlnode_put_attrib(loField,"var","UseGlobalSettings");
	  xmlnode_insert_cdata(xmlnode_insert_tag(loField,"value"),"1",-1);
	  xmlnode_put_attrib(loField=xmlnode_insert_tag(xData,"field"),"type","fixed");
	  xmlnode_insert_cdata(xmlnode_insert_tag(loField,"value"),smtp_rc_GetString(par,lcLang,SMTP_RC_REGISTER_USEGLOBALSETTINGS_DSC),-1);


      // own  setting - attachments
	  xmlnode_put_attrib(loField=xmlnode_insert_tag(xData,"field"),"type","list-single");
	  xmlnode_put_attrib(loField,"label",smtp_rc_GetString(par,lcLang,SMTP_RC_REGISTER_ATTACHMENTS_LBL));
	  xmlnode_put_attrib(loField,"var","attachments");
	  xmlnode_insert_cdata(xmlnode_insert_tag(loField,"value"),"1",-1);
	  xmlnode_put_attrib(loOption=xmlnode_insert_tag(loField,"option"),"label",smtp_rc_GetString(par,lcLang,SMTP_RC_REGISTER_ATTACHMENTS_VAL1_LBL));
	  xmlnode_insert_cdata(xmlnode_insert_tag(loOption,"value"),"1",-1);
	  xmlnode_put_attrib(loOption=xmlnode_insert_tag(loField,"option"),"label",smtp_rc_GetString(par,lcLang,SMTP_RC_REGISTER_ATTACHMENTS_VAL0_LBL));
	  xmlnode_insert_cdata(xmlnode_insert_tag(loOption,"value"),"0",-1);
	  xmlnode_put_attrib(loOption=xmlnode_insert_tag(loField,"option"),"label",smtp_rc_GetString(par,lcLang,SMTP_RC_REGISTER_ATTACHMENTS_VAL2_LBL));
	  xmlnode_insert_cdata(xmlnode_insert_tag(loOption,"value"),"2",-1);
	  xmlnode_put_attrib(loField=xmlnode_insert_tag(xData,"field"),"type","fixed");
	  xmlnode_insert_cdata(xmlnode_insert_tag(loField,"value"),smtp_rc_GetString(par,lcLang,SMTP_RC_REGISTER_ATTACHMENTS_DSC),-1);

	  // own  setting - jabber to mime
	  xmlnode_put_attrib(loField=xmlnode_insert_tag(xData,"field"),"type","boolean");
	  xmlnode_put_attrib(loField,"label",smtp_rc_GetString(par,lcLang,SMTP_RC_REGISTER_PGPJABBERTOMIME_LBL));
	  xmlnode_put_attrib(loField,"var","PGPJabberToMIME");
	  xmlnode_insert_cdata(xmlnode_insert_tag(loField,"value"),"1",-1);
	  xmlnode_put_attrib(loField=xmlnode_insert_tag(xData,"field"),"type","fixed");
	  xmlnode_insert_cdata(xmlnode_insert_tag(loField,"value"),smtp_rc_GetString(par,lcLang,SMTP_RC_REGISTER_PGPJABBERTOMIME_DSC),-1);


	  // own  setting - to jabber non mime to x
	  xmlnode_put_attrib(loField=xmlnode_insert_tag(xData,"field"),"type","boolean");
	  xmlnode_put_attrib(loField,"label",smtp_rc_GetString(par,lcLang,SMTP_RC_REGISTER_PGPTOJABBERNONMIMETOX_LBL));
	  xmlnode_put_attrib(loField,"var","PGPToJabbernonMIMETox");
	  xmlnode_insert_cdata(xmlnode_insert_tag(loField,"value"),"1",-1);
	  xmlnode_put_attrib(loField=xmlnode_insert_tag(xData,"field"),"type","fixed");
	  xmlnode_insert_cdata(xmlnode_insert_tag(loField,"value"),smtp_rc_GetString(par,lcLang,SMTP_RC_REGISTER_PGPTOJABBERNONMIMETOX_DSC),-1);


      liProcess=1;
      }

   if (liProcess==0 && j_strcmp(jp->iqns,NS_REGISTER)==0 && jp->subtype==JPACKET__SET ) //
      {
      // test if submit or cancel
	  xData=xmlnode_get_tag(jp->x,"query/x");
      if (j_strcmp(xmlnode_get_attrib(xData,"type"),"submit")==0) // potvrzeno
         {
         log_debug(ZONE,"REGISTER RESULT");
         for (loField = xmlnode_get_firstchild(xData); loField != NULL; loField = xmlnode_get_nextsibling(loField))
             {
             if (loField->type!=NTYPE_TAG)
	       	    continue;

             log_debug(ZONE,"field: %s, Value: %s", xmlnode_get_attrib(loField,"var"),xmlnode_get_data(xmlnode_get_tag(loField,"value")) );

       
   	         }
         }
	  else // cancel
	     {
         }

      x= out_SetReply(xmlnode_new_tag("iq"),jp->x);
      xmlnode_put_attrib(x,"type","result");
      xmlnode_put_attrib(loQuery=xmlnode_insert_tag(x,"query"),"xmlns",NS_REGISTER);

	  liProcess=1;
      }


   if (liProcess==1)
      {
      deliver(dpacket_new(xmlnode_dup(x)),sin->i);
      xmlnode_free(x);
      }


   return liProcess;
   }

// E:2005-08-29 gorila@dione.zcu.cz
